	device zxspectrum128
        ORG #6000
begin
;	ld sp,$5FE0
	ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir
	ld a,$10,bc,$7ffd:out (c),a
;zero memory
	ld h,$A0
	xor a
zm:
	ld (hl),a
	inc hl
	cp h
	jr nz,zm

;pregenerate N*4/3
	ld bc,PLOTTBL-256
	ld de,$185;$155;256*4/3
	ld hl,0
ge:
	ld a,h
	ld (bc),a
	add hl,de
	inc c
	jr nz,ge

;gen sinus, disassembled part of Fly1k, coz i lost sources /:
		ld	hl, unk_673A	; gensin
		ld	de, $A000
		ld	c, e
		ld	xl, 10h
loc_6535:
		ld	b, 4

loc_6537:
		xor	a
		rl	(hl)
		rla
		rl	(hl)
		rla
		add	a, c
		ld	c, a
		ld	(de), a
		inc	e
		djnz	loc_6537
		inc	hl
		dec	xl
		jr	nz, loc_6535
		ld	h, d
		ld	l, e
loc_654B:
		ld	(de), a
		inc	e
		dec	l
		ld	a, (hl)
		jr	nz, loc_654B

;mult
		ld	hl, $C07F

loc_66F1:				; CODE XREF: sub_66EE+2Cj
		push	hl
		exx
		ld	hl, $A07F
		exx

loc_66F7:
		exx
		ld	a, (hl)
		dec	l
		exx
		ld	e, a

loc_66FC:
		ld	d, 0
		xor	a
		ld	b, 8

loc_6701:
		rr	e
		jr	nc, loc_6706
		add	a, d

loc_6706:
		rra
		djnz	loc_6701
		ld	(hl), a
		dec	l
		jr	nz, loc_66F7
		pop	hl
		ld	a, (loc_66FC+1)
		add	a, 4
		ld	(loc_66FC+1), a
		inc	h
;		ld	a, h
;		cp	0C0h ; ''
		jr	nz, loc_66F1

;negate
		ld	hl, $C000
		ld	e, 80h

loc_6721:
		ld	d, h

loc_6722:
;		ld	a, (hl)
		ld	c,(hl),b,$B7,a,(bc),(hl),a
		neg
;		add	a, 80h ; ''
		ld	(de), a
;		ld	a, (hl)
;		add	a, 80h ; ''
;		ld	(hl), a
		inc	l
		inc	e
		jr	nz, loc_6722
		ld	a, e
		ld	e, l
		ld	l, a
		inc	h
		ld	a, h
;		cp	0C0h ; ''
		jr	nz, loc_6721
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;plot
hist=$B000

PLOTTBL EQU #B800
  call FORMER
;\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;setup im2
	ld hl,$8000
	ld de,$8001
	ld bc,256
	ld (hl),$81
	ldir
	di
	ld a,$80,i,a
	im 2
	
	ld hl,INTVEC,de,$8181
	ld bc,INTVEC_e-INTVEC:ldir

mm:
	ei:halt
;	ld a,0:out ($FE),a

sidi: ld bc,$7F7C;B.C=si/di

;    di+1
	inc c
;    si=#v-di
	ld a,127
	sub c
	ld b,a

	ld a,c
	cp 127
	jr nz,eif1
;    If di=#v;127
;      di=0
	ld c,0

	ld hl,d_b+1
	inc (hl)

;    EndIf
eif1:
	ld (sidi+1),bc

;	inc c
;	dec c
;	jr nz,no_zero_c
;	ld hl,d_b+1
;	inc (hl)
;no_zero_c:

	ld a,c
	srl a
	add a,$C0
	ld (dip+1),a

	ld a,b
	srl a
	add a,$C0
	ld (sip+1),a

	ld ixl,0

a0b0: ld bc,$FEFE
	inc c,c
	inc b,b
	ld (a0b0+1),bc
pll:
;zero
;ze:	ld hl,hist+$300
;	;push hl
;	ld e,(hl):inc h
;	ld d,(hl):inc h
;	ld a,(de)
;	and (hl)
;	ld (de),a
;	;pop hl
;	inc l
;	ld a,l
;	ld (ze+1),a
;    For i=0 To 255

;    a.a=a0
;    b.a=b0
;    For i=0 To 255
;      x.w=(si*c(a)+c(b)*di)/256
;      y.w=(si*s(a)+s(b)*di)/256
sip:
	ld h,$C0
	ld l,c
	ld e,(hl)

	ld a,l
	add a,64
	ld l,a
	ld d,(hl);for Y

dip:
	ld h,$C0
	ld l,b
	ld a,(hl)
	add a,e
	add a,127
	ld e,a

	ld a,l
	add a,64
	ld l,a

	ld a,(hl)
	add a,d
	add a,96
	ld d,a
	
	inc c
	ld a,b
d_b: add a,1
	ld b,a
;      a+da
;      b+db
;      Box (127+x,96+y,1,1,$FFFFFF)
;    Next i

;      Box(x0,y0,1,1,$FFFFFF)
	LD H,HIGH PLOTTBL
	LD L,D
	LD D,(HL)
	INC H
    LD A,(HL)
    LD L,E
    INC H
    OR (HL)
    INC H
    LD E,A
    LD A,(DE)
    OR (HL)
    LD (DE),A

	ld a,(hl)
	cpl
ptr:
	ld hl,hist;+255
	;push hl
	ld (hl),e:inc h
	ld (hl),d:inc h
	ld (hl),a
	;pop hl
	inc l
	ld a,l
	ld (ptr+1),a

;    Next i
	inc ixl
	jp nz,pll

;zero dots
ze:	ld hl,hist+$300
zelp:
	ld c,h
	ld e,(hl):inc h
	ld d,(hl):inc h
	ld a,(de)
	and (hl)
	ld (de),a
	ld h,c
	inc l
	jr nz,zelp

;	ld a,7:out ($FE),a
	ld a,(ptr+2)
	ld (ze+2),a
	xor 3
	ld (ptr+2),a
	jp mm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FORMER  LD DE,#4000,BC,#8000,L,E
FLP1    LD H,high PLOTTBL
        LD (HL),D:INC H:LD (HL),E:INC H
        LD (HL),C:INC H:LD (HL),B
        RRC B
        LD A,C:ADC A,0:LD C,A
FBR1    INC D:LD A,D:AND 7
        JR NZ,FNXT:LD A,E:ADD A,32
        LD E,A:JR C,FNXT
        LD A,D:SUB 8:LD D,A
FNXT    INC L:JR NZ,FLP1
        LD HL,PLOTTBL+#C0,BC,#3F
        LD DE,HL:INC E
        LD (HL),0:LDIR
        RET
; ---------------------------------------------------------------------------
unk_673A:	db  26h
		db  66h
		db  66h
		db  66h
		db  65h
		db  96h
		db  59h
		db  55h
		db  95h
		db  55h
		db  15h
		db  45h
		db  11h
		db  10h
		db  41h
		db    0

;--------------------------------------------------
INTVEC
   PUSH AF,BC,DE,HL
   call psgplay
   POP HL,DE,BC,AF
   EI:RETI
INTVEC_e:
;---------------play PSG dump-----------
psgplay:ld a,1:or a:jr z,psga
 dec a:ld (psgplay+1),a:ret
psga: ld hl,song;+16

dumpreg:
 	ld e,(hl):inc hl
 	ld a,e
 	cp #FF:jr z,stoplay
 	cp #FE:jr nz,nogetwait
    ld e,(hl):inc hl;(hl)*4
 ld a,e
 add a,a
 add a,a
 ld (psgplay+1),a:jr stoplay

nogetwait:
    cp #FD:jr z,stoplay2
	ld bc,0xfffd
	out (c),e
	ld e,(hl):inc hl
	ld b,0xbf
	out (c),e
    jr dumpreg
stoplay2:
  ld hl,song;+16
stoplay:
 ld (psga+1),hl
 ret

song:incbin "tune3.psg"
 db $FD
end

;	page 0
;	org $C000
;page0b:
;	incbin "sintab.dat"
;page0e:

	display /d,end-begin
	savesna "!43.sna",begin
	savebin "va.code",begin,end-begin

	display /d,end-begin
